local mod = foundation.createMod();

prefix = "MARKETTENT";

--elements
--mod:registerAssetId("models/markettent.fbx/Prefab/MarkettentV_Part", "PREFAB_MARKETTENTV")
--mod:registerAssetId("models/markettent.fbx/Prefab/MarkettentJ_Part", "PREFAB_MARKETTENTJ")
--mod:registerAssetId("models/markettent.fbx/Prefab/MarkettentB_Part", "PREFAB_MARKETTENTB")
--mod:registerAssetId("models/markettent.fbx/Prefab/MarkettentR_Part", "PREFAB_MARKETTENTR")

--details
--mod:registerAssetId("models/markettent.fbx/Prefab/Markettent_Sign_1_Part", "PREFAB_MARKETTENT_SIGN_1")

--materiaux
mod:registerAssetId("models/markettent.fbx/Materials/Material", "MATERIAL_TENT")


mod:registerAssetProcessor("models/markettent.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

mod:override({
	Id="MATERIAL_TENT",
	HasAlphaTest = true
})

function registerTentPart( _namePrefab, _nameAsset)
	mod:registerAssetId("models/markettent.fbx/Prefab/" .. _namePrefab .. "_Part", "PREFAB_" .. _nameAsset)
	mod:registerAssetId("models/markettent.fbx/Prefab/" .. _namePrefab .. "_ConstructionSteps", _nameAsset .. "_CONSTRUCTIONSTEPS")

	mod:register({
		DataType = "BUILDING_PART",
		Id = prefix.."_PART_".._nameAsset,
		Name = prefix.."_NAME_".._nameAsset,
		Description = prefix.."_DESC_".._nameAsset,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_" .. _nameAsset
		},
		BuildingZone = {
			ZoneEntryList = {
				{
					Polygon = polygon.createRectangle({3, 3}),
					Type = {
						DEFAULT = true,
						NAVIGABLE = true,
						GRASS_CLEAR = true
					}
				}
			}
		},
		Cost = {
			BuildRightTaxes = {	
				{ Resource = "GOLD_COINS", Quantity = 50 }
			},
			UpkeepCost = {
				{ Resource = "GOLD", Quantity = 10 }
			},
			RessourcesNeeded = {
				{ Resource = "WOOD", Quantity = 10 },
				{ Resource = "WOOLEN_CLOTH", Quantity = 5} 
			}
		},
		EstateSplendor = {
			{
				Estate = "LABOUR",
				Quantity = 2
			}
		},
		ConstructionVisual = _nameAsset .. "_CONSTRUCTIONSTEPS"
	})

	-- sol
	mod:registerPrefabComponent("models/markettent.fbx/Prefab/" .. _namePrefab .. "_Part", {
		DataType = "COMP_GROUNDED"
	})
	--suppression herbe
	mod:registerPrefabComponent("models/markettent.fbx/Prefab/" .. _namePrefab .. "_Part", {
		DataType = "COMP_DIRT_RECTANGLE",
		Size = {3, 3}
	})
end

registerTentPart("MarkettentV", "MARKETTENTV")
registerTentPart("MarkettentJ", "MARKETTENTJ")
registerTentPart("MarkettentB", "MARKETTENTB")
registerTentPart("MarkettentR", "MARKETTENTR")

function registerTentDetails( _namePrefab, _nameAsset, _size)
	mod:registerAssetId("models/markettent.fbx/Prefab/" .. _namePrefab .. "_Part", "PREFAB_" .. _nameAsset)

	mod:register({
		DataType = "BUILDING_PART",
		Id = prefix .. "_PART_" .. _nameAsset,
		Name = prefix .. "_NAME_" .. _nameAsset,
		Description = prefix .. "_DESC_" .. _nameAsset,
		ConstructorData = {
			DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
			CoreObjectPrefab = "PREFAB_" .. _nameAsset
		},
		BuildingZone = {
			ZoneEntryList = {
				{
					Polygon = polygon.createRectangle({_size, 0.5}),
					Type = {
						DEFAULT = true,
						NAVIGABLE = true,
					}
				}
			}
		},
		Cost = {
			RessourcesNeeded = {
				{ Resource = "WOOD", Quantity = 1  },
			}
		}
	})

	mod:registerPrefabComponent("models/markettent.fbx/Prefab/" .. _namePrefab .. "_Part", {
		DataType = "COMP_BUILDING_PART",
		BuildingPartType = ATTACH_NODE_TYPE.MINOR
	})
end

registerTentDetails("Markettent_Sign_1A", "MARKETTENT_SIGN_1A", 3)
registerTentDetails("Markettent_Sign_1B", "MARKETTENT_SIGN_1B", 3)
registerTentDetails("Markettent_Sign_1C", "MARKETTENT_SIGN_1C", 3)
registerTentDetails("Markettent_Sign_2A", "MARKETTENT_SIGN_2A", 1)
registerTentDetails("Markettent_Sign_2B", "MARKETTENT_SIGN_2B", 1)
registerTentDetails("Markettent_Sign_2C", "MARKETTENT_SIGN_2C", 1)
registerTentDetails("Markettent_Sign_2D", "MARKETTENT_SIGN_2D", 1)
registerTentDetails("Markettent_Sign_2E", "MARKETTENT_SIGN_2E", 1)
registerTentDetails("Markettent_Sign_2F", "MARKETTENT_SIGN_2F", 1)
registerTentDetails("Markettent_Sign_3A", "MARKETTENT_SIGN_3A", 0.5)
registerTentDetails("Markettent_Sign_3B", "MARKETTENT_SIGN_3B", 0.5)


--mod:registerPrefabComponent("models/markettent.fbx/Prefab/Markettent_Sign_1_Part", {
--	DataType = "COMP_BUILDING_PART",
--	BuildingPartType = ATTACH_NODE_TYPE.MINOR
--})

mod:override({
	Id = "MONUMENT_MARKET",
	BuildingPartSetList = {
		Action = "APPEND",
		{
			Name = "PARTSETLIST_NAME",
			BuildingPartList = {
				"MARKETTENT_PART_MARKETTENTV",
				"MARKETTENT_PART_MARKETTENTJ",
				"MARKETTENT_PART_MARKETTENTB",
				"MARKETTENT_PART_MARKETTENTR"
			}
		},
		{
			Name = "PARTSETLIST_NAME_2",
			BuildingPartList = {
				"MARKETTENT_PART_MARKETTENT_SIGN_1A",
				"MARKETTENT_PART_MARKETTENT_SIGN_1B",
				"MARKETTENT_PART_MARKETTENT_SIGN_1C",
				"MARKETTENT_PART_MARKETTENT_SIGN_2A",
				"MARKETTENT_PART_MARKETTENT_SIGN_2B",
				"MARKETTENT_PART_MARKETTENT_SIGN_2C",
				"MARKETTENT_PART_MARKETTENT_SIGN_2D",
				"MARKETTENT_PART_MARKETTENT_SIGN_2E",
				"MARKETTENT_PART_MARKETTENT_SIGN_2F",
				"MARKETTENT_PART_MARKETTENT_SIGN_3A",
				"MARKETTENT_PART_MARKETTENT_SIGN_3B"
			}
		}
	}
})